#include <iostream>
#include <iomanip>
#include <ctime> // Zeitmessung  
#include "interval.hpp"
#include "rmath.hpp"
#include "imath.hpp"

using namespace std;
using namespace cxsc;

void start_clock(clock_t& t1); // Startet den Timer 
void print_time_used(clock_t t1); 
double return_time_used(clock_t t1); 
   
 
int main(void)
{
   int kMax= 5000000; // Schleifendurchlaeufe zur Zeitmessung
   //int kMax=1;
   clock_t t; // Datentyp in <ctime> definiert
   double ret_time1,ret_time2,ret_time3,ret_time4;
   
   string
   comp_name,comp_cpu,comp_ram,comp_os,comp_c,comp_copt,comp_cpp,comp_cppopt;
   cout << "Benchmark Program for C-XSC Library" << endl;
   cout << "Please insert some information about your system:" << endl;
   cout << "Name of your computer?  "; getline(cin,comp_name); //cin >> comp_name;
   cout << "Which CPU?              "; getline(cin,comp_cpu); //cin >> comp_cpu;
   cout << "RAM?                    "; getline(cin,comp_ram); //cin >> comp_ram;
   cout << "Operation System (OS)?  "; getline(cin,comp_os); //cin >> comp_os;
   cout << "C-Compiler (version)?   "; getline(cin,comp_c); //cin >> comp_c;
   cout << "Used Compiler options?  "; getline(cin,comp_copt); //cin >> comp_copt;
   cout << "C++-Compiler (version)? "; getline(cin,comp_cpp); //cin >> comp_cpp;
   cout << "Used Compiler options?  "; getline(cin,comp_cppopt); //cin >> comp_cppopt;
   cout << endl << endl;;                


   cout << "Benchmark Program for C-XSC Library - Protocol" << endl;
   cout << "==============================================" << endl << endl;
   cout << "Some information about the computer system: " << endl << endl;;
   cout << "  Computer name: " << comp_name << endl;
   cout << "  CPU:           " << comp_cpu << " with " << comp_ram << " RAM" << endl;
   cout << "  OS:            " << comp_os << endl;
   cout << "  C-Compiler:    " << comp_c << " with options: " << comp_copt << endl;
   cout << "  C++-Compiler:  " << comp_cpp << " with options: " << comp_cppopt << endl;
   cout << endl; 

   cout << endl;
   cout << "Basic Operations:" << endl;
   cout << "-----------------" << endl << endl;

   double ad, bd, cd;
   ad = 1.23456789e4;
   bd = 4.6536727255666354e-1;
   real ar, br, cr;
   ar = 1.23456789e4;
   br = 4.6536727255666354e-1;
   cout << "Number of operations: " << kMax << "  -  All time measurements in msec." << endl << endl;
 
   cout << "Column:    (1)  |    (2)     |    (3)     |    (4)" << endl;
   cout << "Datatyp: double | cxsc::real | cxsc::real | cxsc::real  factor |factor |factor" << endl;
   cout << "Rnd.:    nearest|   nearest  | downwards  |   upwards   (2)/(1)|(3)/(1)|(4)/(1)" << endl;
   cout << "----------------+------------+------------+-----------  -------+-------+-------" << endl;

   cout << fixed << setprecision(1);
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = ad + bd; }  
   ret_time1=return_time_used(t); 
   cout << "Addition" << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = ar + br; }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = addd(ar,br); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "  |";
 
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = addu(ar,br); }  
   ret_time4=return_time_used(t); 
   cout << setw(9) << ret_time4 << "   ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time4/ret_time1 << endl;

// -----------------------------------------------------------------
 
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = ad - bd; }  
   ret_time1=return_time_used(t); 
   cout << "Subtr.  " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = ar - br; }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = subd(ar,br); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "  |";
 
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = subu(ar,br); }  
   ret_time4=return_time_used(t); 
   cout << setw(9) << ret_time4 << "   ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time4/ret_time1 << endl;

// -----------------------------------------------------------------


   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = ad * bd; }  
   ret_time1=return_time_used(t); 
   cout << "Mult.   " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = ar * br; }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = muld(ar,br); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "  |";
 
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = mulu(ar,br); }  
   ret_time4=return_time_used(t); 
   cout << setw(9) << ret_time4 << "   ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time4/ret_time1 << endl;

// -----------------------------------------------------------------
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = ad / bd; }  
   ret_time1=return_time_used(t); 
   cout << "Division" << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = ar / br; }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = divd(ar,br); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "  |";
 
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = divu(ar,br); }  
   ret_time4=return_time_used(t); 
   cout << setw(9) << ret_time4 << "   ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time4/ret_time1 << endl;

// -----------------------------------------------------------------

   cout << endl;
   cout << "Elementary Functions:" << endl;
   cout << "---------------------" << endl << endl;
   
//   kMax /= 10; 
   cout << "Number of operations: " << kMax << "  -  All time measurements in msec." << endl << endl;
 
   cout << "Column:    (1)  |    (2)     |    (3)" << endl;
   cout << "Datatyp: double | cxsc::real | cxsc::interval  factor |factor |factor" << endl;
   cout << "                |            |                 (2)/(1)|(3)/(1)|(3)/(2)" << endl;
   cout << "----------------+------------+---------------  -------+-------+-------" << endl;

   interval ai,bi,ci;
   ai=interval(ar,ar*1.01);
   bi=interval(br,br*1.01);

   cout << fixed << setprecision(1);
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = exp(bd); }  
   ret_time1=return_time_used(t); 
   cout << "exp     " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = exp(br); }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { ci = exp(bi); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "      ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time2 << endl;

// -----------------------------------------------------------------
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = log(bd); }  
   ret_time1=return_time_used(t); 
   cout << "log     " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = ln(br); }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { ci = ln(bi); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "      ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time2 << endl;

// -----------------------------------------------------------------
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = sin(bd); }  
   ret_time1=return_time_used(t); 
   cout << "sin     " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = sin(br); }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { ci = sin(bi); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "      ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time2 << endl;

// -----------------------------------------------------------------
   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cd = cos(bd); }  
   ret_time1=return_time_used(t); 
   cout << "cos     " << setw(7) <<  ret_time1 << " |  ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { cr = cos(br); }  
   ret_time2=return_time_used(t); 
   cout << setw(9) << ret_time2 << " | ";

   start_clock(t); 
   for (int k= 0; k< kMax; k++) { ci = cos(bi); }  
   ret_time3=return_time_used(t); 
   cout << setw(9) << ret_time3 << "      ";

   cout << "  " << setw(4)<< ret_time2/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time1;
   cout << "  | " << setw(4) << ret_time3/ret_time2 << endl;

// -----------------------------------------------------------------
  
   cout << endl;
   cout << "Programmausgabe zur Quellcodedatei: " << __FILE__ << endl;
   return 0;  // Programmende
}

void start_clock(clock_t& t1)
{
   //clock_t 
   t1= clock();
   if (t1 == clock_t(-1))  // Abbruch, falls timer nicht richtig arbeitet 
   {
      cerr << "sorry, no clock\n";
      exit(1);
   }
   return;
}

double return_time_used(clock_t t1)
{
   clock_t t2= clock();
   if (t2 == clock_t(-1))
   {
     cerr<< " sorry, clock overflow\n";
     exit(2);
   }
   return(1000*double(t2-t1)/CLOCKS_PER_SEC);
} 

void print_time_used(clock_t t1)
{
   clock_t t2= clock();
   if (t2 == clock_t(-1))
   {
     cerr<< " sorry, clock overflow\n";
     exit(2);
   }
   cout << "Time  used: " << 1000*double(t2-t1)/CLOCKS_PER_SEC
        << " msec" << endl;
   return;
} 
   

